%{
#include "y.tab.h"
%}

comment		"/*"([^\*\/]|\*[^/]|[^\*]\/)*"*/"
delim		[ \t\n]
ws		{delim}+
reg		("r"[0-9])|("r1"[0-5])
digit		[0-9]
number		{digit}+
addr		{number}":"

%%

{comment}	{}
{ws}		{}
{addr}		{ return (ADDR);    }
{number}	{ return (NUMBER);  }
{reg}		{ return (REG);     }
"and"		{ return (ANDINST); }
"or"		{ return (ORINST);  }
"xor"		{ return (XORINST); }
"not"		{ return (NOTINST); }
"add"		{ return (ADDINST); }
"sub"		{ return (SUBINST); }
"inc"		{ return (INCINST); }
"dec"		{ return (DECINST); }
"shl"		{ return (SHLINST); }
"shr"		{ return (SHRINST); }
"cmp"		{ return (CMPINST); }
"jmp"		{ return (JMPINST); }
"jeq"		{ return (JEQINST); }
"jne"		{ return (JNEINST); }
"jgt"		{ return (JGTINST); }
"jge"		{ return (JGEINST); }
"jlt"		{ return (JLTINST); }
"jle"		{ return (JLEINST); }
"st"		{ return (STINST);  }
"ld"		{ return (LDINST);  }
"mov"		{ return (MOVINST); }
"stop"		{ return (STOPINST);}
"nop"		{ return (NOPINST); }
","		{ return (COMMA);   }

%%
