%{

#include<stdio.h>
#include<stdlib.h>
#define MEMDATA "memdata(%d)<=\"%s\";\n"

int yylex();
int yyerror(char *s);
extern char *yytext;
extern FILE *yyin;
char inst[64];

char *to4bits(int i)
{
	char *bits;
	int n;
	bits=(char *)malloc(5);
	for(n=0;n<4;n++)
		bits[3-n]=((i>>n)&1)+'0';
	bits[4]='\0';
	return bits;
}

char *to8bits(int i)
{
	char *bits;
	int n;
	bits=(char *)malloc(9);
	for(n=0;n<8;n++)
		bits[7-n]=((i>>n)&1)+'0';
	bits[8]='\0';
	return bits;
}

char *to16bits(int i)
{
	char *bits;
	int n;
	bits=(char *)malloc(17);
	for(n=0;n<16;n++)
		bits[15-n]=((i>>n)&1)+'0';
	bits[16]='\0';
	return bits;
}

%}

%token ADDR
%token COMMA
%token NUMBER
%token REG
%token ANDINST ORINST XORINST NOTINST ADDINST SUBINST INCINST DECINST SHLINST SHRINST CMPINST JMPINST JEQINST JNEINST JGTINST JGEINST JLTINST JLEINST STINST LDINST MOVINST STOPINST NOPINST

%%

program
	:	statementlist
		{
			$$=$1;
		}
	;
statementlist
	:	statementlist statement
		{
			if($1!=0)
			{
				$$=$1;
			}
			else
				$$=$2;
		}
	|	empty
		{
			$$=0;
		}
	;
statement
	:	address instruction register
		{
			strcpy(inst,"1011");
			strcat(inst,"0000");
			strcat(inst,to4bits($3));
			switch($2)
			{
				case JMPINST:
					strcat(inst,"0000");
					break;
				case JEQINST:
					strcat(inst,"0001");
					break;
				case JNEINST:
					strcat(inst,"0010");
					break;
				case JGTINST:
					strcat(inst,"0011");
					break;
				case JGEINST:
					strcat(inst,"0100");
					break;
				case JLTINST:
					strcat(inst,"0101");
					break;
				case JLEINST:
					strcat(inst,"0110");
					break;
				default:
					printf("Syntax error at %d\n",$1);
					printf("address instruction register error\n");
					exit(0);
					break;
			}
			printf(MEMDATA,$1,inst);
		}
	|	address instruction register COMMA register
		{
			switch($2)
			{
				case ANDINST:
					strcpy(inst,"0000");
					break;
				case ORINST:
					strcpy(inst,"0001");
					break;
				case XORINST:
					strcpy(inst,"0010");
					break;
				case NOTINST:
					strcpy(inst,"0011");
					break;
				case ADDINST:
					strcpy(inst,"0100");
					break;
				case SUBINST:
					strcpy(inst,"0101");
					break;
				case INCINST:
					strcpy(inst,"0110");
					break;
				case DECINST:
					strcpy(inst,"0111");
					break;
				case SHLINST:
					strcpy(inst,"1000");
					break;
				case SHRINST:
					strcpy(inst,"1001");
					break;
				case CMPINST:
					strcpy(inst,"1010");
					break;
				case STINST:
					strcpy(inst,"1100");
					break;
				case LDINST:
					strcpy(inst,"1101");
					break;
				default:
					break;
			}
			strcat(inst,to4bits($3));
			strcat(inst,to4bits($5));
			strcat(inst,"0000");
			printf(MEMDATA,$1,inst);
		}
	|	address instruction register COMMA number
		{
			switch($2)
			{
				case MOVINST:
					strcpy(inst,"1110");
					strcat(inst,to4bits($3));
					strcat(inst,to8bits($5));
					break;
				default:
					printf("Syntax error at %d\n",$1);
					printf("address instruction register COMMA number error\n");
					exit(0);
					break;
			}
			printf(MEMDATA,$1,inst);
		}
	|	address instruction
		{
			switch($2)
			{
				case STOPINST:
					printf(MEMDATA,$1,"1111000000000000");
					break;
				case NOPINST:
					printf(MEMDATA,$1,"1111111111111111");
					break;
				default:
					printf("Syntax error at %d\n",$1);
					printf("address instruction error\n");
					exit(0);
					break;
			}
		}
	|	address number
		{
			strcpy(inst,to16bits($2));
			printf(MEMDATA,$1,inst);
		}
	;
address
	:	ADDR
		{
			yytext[strlen(yytext)-1]='\0';
			$$=atoi(yytext);
		}
	;
instruction
	:	ANDINST
		{
			$$=ANDINST;
		}
	|	ADDINST
		{
			$$=ADDINST;
		}
	|	ORINST
		{
			$$=ORINST;
		}
	|	XORINST
		{
			$$=XORINST;
		}
	|	NOTINST
		{
			$$=NOTINST;
		}
	|	ADDINST
		{
			$$=ADDINST;
		}
	|	SUBINST
		{
			$$=SUBINST;
		}
	|	INCINST
		{
			$$=INCINST;
		}
	|	DECINST
		{
			$$=DECINST;
		}
	|	SHLINST
		{
			$$=SHLINST;
		}
	|	SHRINST
		{
			$$=SHRINST;
		}
	|	CMPINST
		{
			$$=CMPINST;
		}
	|	JMPINST
		{
			$$=JMPINST;
		}
	|	JEQINST
		{
			$$=JEQINST;
		}
	|	JNEINST
		{
			$$=JNEINST;
		}
	|	JGTINST
		{
			$$=JGTINST;
		}
	|	JGEINST
		{
			$$=JGEINST;
		}
	|	JLTINST
		{
			$$=JLTINST;
		}
	|	JLEINST
		{
			$$=JLEINST;
		}
	|	STINST
		{
			$$=STINST;
		}
	|	LDINST
		{
			$$=LDINST;
		}
	|	MOVINST
		{
			$$=MOVINST;
		}
	|	STOPINST
		{
			$$=STOPINST;
		}
	|	NOPINST
		{
			$$=NOPINST;
		}
	;
register
	:	REG
		{
			$$=atoi(yytext+1);
		}
	;
number
	:	NUMBER
		{
			$$=atoi(yytext);
		}
empty
	:
		{
			$$=0;
		}
	;

%%

main(int argc,char **argv)
{
	++argv;
	--argc;
	if(argc>0)
		yyin=fopen(argv[0],"r");
	else
		yyin=stdin;
	yyparse();
}

int yyerror(char *s)
{
	fprintf(stderr,"%s\n",s);
	return 1;
}
