library ieee;
use ieee.std_logic_1164.all,ieee.numeric_std.all;

entity clu2 is
port
(
	opcode:in std_logic_vector(3 downto 0);
	condition:in std_logic_vector(3 downto 0);
	cout_flag:in std_logic;
	zero_flag:in std_logic;
	overflow_flag:in std_logic;
	set_flag:in std_logic;
	SelConst:out std_logic;
	BRPC:out std_logic
);
end clu2;

architecture clu2_beh of clu2 is
begin
	process(opcode,condition)
	variable tjump:std_logic;
	begin
		tjump:='0';
		SelConst<='0';
		BRPC<='0';

		case opcode(3 downto 0) is
			-- MOV
			when "1110"=>
				SelConst<='1';
			-- JMP
			when "1011"=>
				case condition(3 downto 0) is
					-- JMP
					when "0000"=>
						tjump:='1';
					-- JEQ
					when "0001"=>
						if(zero_flag='1') then
							tjump:='1';
						end if;
					-- JNE
					when "0010"=>
						if(zero_flag='0') then
							tjump:='1';
						end if;
					-- JGT
					when "0011"=>
						if(set_flag='0' and zero_flag='0') then
							tjump:='1';
						end if;
					-- JGE
					when "0100"=>
						if(set_flag='0') then
							tjump:='1';
						end if;
					-- JLT
					when "0101"=>
						if(set_flag='1') then
							tjump:='1';
						end if;
					-- JLE
					when "0110"=>
						if(set_flag='1' or zero_flag='1') then
							tjump:='1';
						end if;
					when others=>
						SelConst<='0';
						BRPC<='0';
				end case;
				if(tjump='1') then
					BRPC<='1';
				end if;
			when others=>
				SelConst<='0';
				BRPC<='0';
		end case;
	end process;
end clu2_beh;
