library ieee;
use ieee.std_logic_1164.all,ieee.numeric_std.all;

entity clu3 is
port
(
	opcode:in std_logic_vector(3 downto 0);
	ALUSel:out std_logic_vector(4 downto 0);
	Cin:out std_logic;
	Sin:out std_logic
);
end clu3;

architecture clu3_beh of clu3 is
begin
	process(opcode)
	begin
		ALUSel<="00000";
		Cin<='0';
		Sin<='0';

		case opcode(3 downto 0) is
			-- AND
			when "0000"=>
				ALUSel<="00100";
			-- OR
			when "0001"=>
				ALUSel<="00101";
			-- XOR
			when "0010"=>
				ALUSel<="00110";
			-- NOT
			when "0011"=>
				ALUSel<="00111";
			-- ADD
			when "0100"=>
				ALUSel<="00001";
			-- SUB
			when "0101"=>
				ALUSel<="00010";
				Cin<='1';
			-- INC
			when "0110"=>
				ALUSel<="00000";
				Cin<='1';
			-- DEC
			when "0111"=>
				ALUSel<="00011";
			-- SHL
			when "1000"=>
				ALUSel<="01000";
			-- SHR
			when "1001"=>
				ALUSel<="10000";
			-- CMP
			when "1010"=>
				Sin<='1';
			-- ST
			when "1100"=>
				ALUSel<="00011";
				Cin<='1';
			-- LD
			when "1101"=>
				ALUSel<="00011";
				Cin<='1';
			-- MOV
			when "1110"=>
				ALUSel<="00011";
				Cin<='1';
			when others=>
				ALUSel<="00000";
				Cin<='0';
				Sin<='0';
		end case;
	end process;
end clu3_beh;
