library ieee;
use ieee.std_logic_1164.all,ieee.numeric_std.all;

entity clu4 is
port
(
	opcode:in std_logic_vector(3 downto 0);
	SelALU:out std_logic;
	Min:out std_logic
);
end clu4;

architecture clu4_beh of clu4 is
begin
	process(opcode)
	begin
		SelALU<='0';
		Min<='0';
		case opcode(3 downto 0) is
			-- AND
			when "0000"=>
				SelALU<='1';
			-- OR
			when "0001"=>
				SelALU<='1';
			-- XOR
			when "0010"=>
				SelALU<='1';
			-- NOT
			when "0011"=>
				SelALU<='1';
			-- ADD
			when "0100"=>
				SelALU<='1';
			-- SUB
			when "0101"=>
				SelALU<='1';
			-- INC
			when "0110"=>
				SelALU<='1';
			-- DEC
			when "0111"=>
				SelALU<='1';
			-- SHL
			when "1000"=>
				SelALU<='1';
			-- SHR
			when "1001"=>
				SelALU<='1';
			-- ST
			when "1100"=>
				Min<='1';
			-- MOV 
			when "1110"=>
				SelALU<='1';
			when others=>
				SelALU<='0';
				Min<='0';
		end case;
	end process;
end clu4_beh;
