library ieee;
use ieee.std_logic_1164.all,ieee.numeric_std.all;

entity clu5 is
port
(
	opcode:in std_logic_vector(3 downto 0);
	Rin:out std_logic
);
end clu5;

architecture clu5_beh of clu5 is
begin
	process(opcode)
	begin
		Rin<='0';
		case opcode(3 downto 0) is
			-- AND
			when "0000"=>
				Rin<='1';
			-- OR
			when "0001"=>
				Rin<='1';
			-- XOR
			when "0010"=>
				Rin<='1';
			-- NOT
			when "0011"=>
				Rin<='1';
			-- ADD
			when "0100"=>
				Rin<='1';
			-- SUB
			when "0101"=>
				Rin<='1';
			-- INC
			when "0110"=>
				Rin<='1';
			-- DEC
			when "0111"=>
				Rin<='1';
			-- SHL
			when "1000"=>
				Rin<='1';
			-- SHR
			when "1001"=>
				Rin<='1';
			-- LD
			when "1101"=>
				Rin<='1';
			-- MOV 
			when "1110"=>
				Rin<='1';
			when others=>
				Rin<='0';
		end case;
	end process;
end clu5_beh;
