library ieee;
use ieee.std_logic_1164.all,ieee.numeric_std.all;

entity cpu_16 is
end cpu_16;

architecture cpu_16_beh of cpu_16 is
component alu_16
port
(
	sel:in std_logic_vector(4 downto 0); 
	cin:in std_logic;
	a,b:in std_logic_vector(15 downto 0);
	y:out std_logic_vector(15 downto 0);
	zero_flag:out std_logic;
	overflow_flag:out std_logic;
	set_flag:out std_logic;
	cout_flag:out std_logic
);
end component;
component clock_1
port
(
	clock:out std_logic
);
end component;
component clu2
port
(
	opcode:in std_logic_vector(3 downto 0);
	condition:in std_logic_vector(3 downto 0);
	cout_flag:in std_logic;
	zero_flag:in std_logic;
	overflow_flag:in std_logic;
	set_flag:in std_logic;
	SelConst:out std_logic;
	BRPC:out std_logic
);
end component;
component clu3
port
(
	opcode:in std_logic_vector(3 downto 0);
	ALUSel:out std_logic_vector(4 downto 0);
	Cin:out std_logic;
	Sin:out std_logic
);
end component;
component clu4
port
(
	opcode:in std_logic_vector(3 downto 0);
	SelALU:out std_logic;
	Min:out std_logic
);
end component;
component clu5
port
(
	opcode:in std_logic_vector(3 downto 0);
	Rin:out std_logic
);
end component;
component data_mem_16
port
(
	clock:in std_logic;
	write:in std_logic;
	addr:in std_logic_vector(15 downto 0);
	write_data:in std_logic_vector(15 downto 0);
	read_data:out std_logic_vector(15 downto 0)
);
end component;
component dummy
port
(
	in_1:in std_logic;
	in_4:in std_logic_vector(3 downto 0);
	in_16:in std_logic_vector(15 downto 0)
);
end component;
component false_1
port
(
	out0:out std_logic
);
end component;
component false_5
port
(
	out0:out std_logic_vector(4 downto 0)
);
end component;
component false_16
port
(
	out0:out std_logic_vector(15 downto 0)
);
end component;
component hazard
port
(
	ir2:in std_logic_vector(15 downto 0);
	ir3:in std_logic_vector(15 downto 0);
	ir4:in std_logic_vector(15 downto 0);
	ir5:in std_logic_vector(15 downto 0);
	pause1:out std_logic;
	pause2:out std_logic;
	pause3:out std_logic;
	pause4:out std_logic;
	pause5:out std_logic;
	nopir2:out std_logic;
	nopir3:out std_logic;
	nopir4:out std_logic;
	nopir5:out std_logic
);
end component;
component inst_mem_16
port
(
	clock:in std_logic;
	write:in std_logic;
	addr:in std_logic_vector(15 downto 0);
	write_data:in std_logic_vector(15 downto 0);
	read_data:out std_logic_vector(15 downto 0)
);
end component;
component ir_16
port
(
	clock:in std_logic;
	write:in std_logic;
	in0:in std_logic_vector(15 downto 0);
	out0:out std_logic_vector(15 downto 0);
	opcode:out std_logic_vector(3 downto 0);
	reg0:out std_logic_vector(3 downto 0);
	reg1:out std_logic_vector(3 downto 0);
	condition:out std_logic_vector(3 downto 0);
	const:out std_logic_vector(15 downto 0)
);
end component;
component mux2to1_16
port
(
	sel:in std_logic;
	in0:in std_logic_vector(15 downto 0);
	in1:in std_logic_vector(15 downto 0);
	out0:out std_logic_vector(15 downto 0)
);
end component;
component pause_clock_1
port
(
	clock:in std_logic;
	pause:in std_logic;
	pause_clock:out std_logic
);
end component;
component pc_cont_1
port
(
	branch:in std_logic;
	pause:in std_logic;
	pc_cont:out std_logic
);
end component;
component reg_16
port
(
	clock:in std_logic;
	write:in std_logic;
	in0:in std_logic_vector(15 downto 0);
	out0:out std_logic_vector(15 downto 0)
);
end component;
component regfile_16
port
(
	clock:in std_logic;
	write:in std_logic;
	sel_write_reg:in std_logic_vector(3 downto 0);
	sel_read_reg0:in std_logic_vector(3 downto 0);
	sel_read_reg1:in std_logic_vector(3 downto 0);
	write_data:in std_logic_vector(15 downto 0);
	read_data0:out std_logic_vector(15 downto 0);
	read_data1:out std_logic_vector(15 downto 0)
);
end component;
component sreg
port
(
	clock:in std_logic;
	write:in std_logic;
	in_cout_flag:in std_logic;
	in_zero_flag:in std_logic;
	in_overflow_flag:in std_logic;
	in_set_flag:in std_logic;
	out_cout_flag:out std_logic;
	out_zero_flag:out std_logic;
	out_overflow_flag:out std_logic;
	out_set_flag:out std_logic
);
end component;
component true_1
port
(
	out0:out std_logic
);
end component;
component true_16
port
(
	out0:out std_logic_vector(15 downto 0)
);
end component;
signal ir2_data:std_logic_vector(15 downto 0);
signal ir3_data:std_logic_vector(15 downto 0);
signal ir4_data:std_logic_vector(15 downto 0);
signal ir5_data:std_logic_vector(15 downto 0);
signal clock:std_logic;
signal pclock1:std_logic;
signal pclock2:std_logic;
signal pclock3:std_logic;
signal pclock4:std_logic;
signal pclock5:std_logic;
signal pause1:std_logic;
signal pause2:std_logic;
signal pause3:std_logic;
signal pause4:std_logic;
signal pause5:std_logic;
signal nopir2:std_logic;
signal nopir3:std_logic;
signal nopir4:std_logic;
signal nopir5:std_logic;
signal inst_addr:std_logic_vector(15 downto 0);
signal next_inst_addr:std_logic_vector(15 downto 0);
signal inst_addr_inc:std_logic_vector(15 downto 0);
signal ir2_input:std_logic_vector(15 downto 0);
signal ir3_input:std_logic_vector(15 downto 0);
signal ir4_input:std_logic_vector(15 downto 0);
signal ir5_input:std_logic_vector(15 downto 0);
signal const:std_logic_vector(15 downto 0);
signal reg0_data:std_logic_vector(15 downto 0);
signal reg1_data:std_logic_vector(15 downto 0);
signal write_reg_data:std_logic_vector(15 downto 0);
signal sel_reg0:std_logic_vector(3 downto 0);
signal sel_reg1:std_logic_vector(3 downto 0);
signal ir2_opcode:std_logic_vector(3 downto 0);
signal ir2_cond:std_logic_vector(3 downto 0);
signal sel_const:std_logic;
signal reg_data:std_logic_vector(15 downto 0);
signal brpc:std_logic;
signal set_in:std_logic;
signal overflow_in:std_logic;
signal zero_in:std_logic;
signal cout_in:std_logic;
signal set_out:std_logic;
signal overflow_out:std_logic;
signal zero_out:std_logic;
signal cout_out:std_logic;
signal sel_write_reg:std_logic_vector(3 downto 0);
signal rin:std_logic;
signal ir3_opcode:std_logic_vector(3 downto 0);
signal s4_in:std_logic;
signal z4_input:std_logic_vector(15 downto 0);
signal z4_output:std_logic_vector(15 downto 0);
signal ir4_opcode:std_logic_vector(3 downto 0);
signal md4_output:std_logic_vector(15 downto 0);
signal z5_input:std_logic_vector(15 downto 0);
signal sel_alu:std_logic;
signal m_in:std_logic;
signal m_out:std_logic_vector(15 downto 0);
signal ir5_opcode:std_logic_vector(3 downto 0);
signal inst_data:std_logic_vector(15 downto 0);
signal pc_in:std_logic;
signal alu_a:std_logic_vector(15 downto 0);
signal alu_b:std_logic_vector(15 downto 0);
signal alu_cin:std_logic;
signal alu_sel:std_logic_vector(4 downto 0);

signal bit_true_1:std_logic;
signal bit_true_16:std_logic_vector(15 downto 0);
signal bit_false_1:std_logic;
signal bit_false_5:std_logic_vector(4 downto 0);
signal bit_false_16:std_logic_vector(15 downto 0);
signal dummy_1:std_logic;
signal dummy_4:std_logic_vector(3 downto 0);
signal dummy_16:std_logic_vector(15 downto 0);

begin 
	mp_false_1:false_1 port map(bit_false_1);
	mp_false_5:false_5 port map(bit_false_5);
	mp_false_16:false_16 port map(bit_false_16);
	mp_true_1:true_1 port map(bit_true_1);
	mp_true_16:true_16 port map(bit_true_16);
	mp_dummy:dummy port map(dummy_1,dummy_4,dummy_16);
	mp_clock:clock_1 port map(clock);
	mp_pauseclock1:pause_clock_1 port map(clock,pause1,pclock1);
	mp_pauseclock2:pause_clock_1 port map(clock,pause2,pclock2);
	mp_pauseclock3:pause_clock_1 port map(clock,pause3,pclock3);
	mp_pauseclock4:pause_clock_1 port map(clock,pause4,pclock4);
	mp_pauseclock5:pause_clock_1 port map(clock,pause5,pclock5);

	mp_inst_mem:inst_mem_16 port map(pclock1,bit_false_1,inst_addr,bit_false_16,inst_data);
	mp_alu2:alu_16 port map(alu_sel,alu_cin,alu_a,alu_b,z4_input,zero_in,overflow_in,set_in,cout_in);
	mp_regfile:regfile_16 port map(pclock5,rin,sel_write_reg,sel_reg0,sel_reg1,write_reg_data,reg0_data,reg1_data);
	mp_data_mem:data_mem_16 port map(pclock4,m_in,z4_output,md4_output,m_out);
	mp_s4:sreg port map(pclock4,s4_in,cout_in,zero_in,overflow_in,set_in,cout_out,zero_out,overflow_out,set_out);
	mp_alu1:alu_16 port map(bit_false_5,bit_true_1,bit_false_16,inst_addr,inst_addr_inc,dummy_1,dummy_1,dummy_1,dummy_1);
	mp_mux1:mux2to1_16 port map(nopir2,inst_data,bit_true_16,ir2_input);
	mp_pc_cont:pc_cont_1 port map(brpc,pause1,pc_in);
	mp_pc:reg_16 port map(pclock2,pc_in,next_inst_addr,inst_addr);
	mp_mux2:mux2to1_16 port map(brpc,inst_addr_inc,reg1_data,next_inst_addr);
	mp_ir2:ir_16 port map(pclock2,bit_true_1,ir2_input,ir2_data,ir2_opcode,sel_reg0,sel_reg1,ir2_cond,const);
	mp_clu2:clu2 port map(ir2_opcode,ir2_cond,cout_out,zero_out,overflow_out,set_out,sel_const,brpc);
	mp_mux3:mux2to1_16 port map(nopir3,ir2_data,bit_true_16,ir3_input);
	mp_mux4:mux2to1_16 port map(sel_const,reg1_data,const,reg_data);
	mp_ir3:ir_16 port map(pclock3,bit_true_1,ir3_input,ir3_data,ir3_opcode,dummy_4,dummy_4,dummy_4,dummy_16);
	mp_y3:reg_16 port map(pclock3,bit_true_1,reg_data,alu_b);
	mp_x3:reg_16 port map(pclock3,bit_true_1,reg0_data,alu_a);
	mp_clu3:clu3 port map(ir3_opcode,alu_sel,alu_cin,s4_in);
	mp_mux5:mux2to1_16 port map(nopir4,ir3_data,bit_true_16,ir4_input);
	mp_ir4:ir_16 port map(pclock4,bit_true_1,ir4_input,ir4_data,ir4_opcode,dummy_4,dummy_4,dummy_4,dummy_16);
	mp_md4:reg_16 port map(pclock4,bit_true_1,alu_a,md4_output);
	mp_z4:reg_16 port map(pclock4,bit_true_1,z4_input,z4_output);
	mp_clu4:clu4 port map(ir4_opcode,sel_alu,m_in);
	mp_mux6:mux2to1_16 port map(nopir5,ir4_data,bit_true_16,ir5_input);
	mp_mux7:mux2to1_16 port map(sel_alu,m_out,z4_output,z5_input);
	mp_ir5:ir_16 port map(pclock5,bit_true_1,ir5_input,ir5_data,ir5_opcode,sel_write_reg,dummy_4,dummy_4,dummy_16);
	mp_z5:reg_16 port map(pclock5,bit_true_1,z5_input,write_reg_data);
	mp_clu5:clu5 port map(ir5_opcode,rin);
	mp_hazard:hazard port map(ir2_data,ir3_data,ir4_data,ir5_data,pause1,pause2,pause3,pause4,pause5,nopir2,nopir3,nopir4,nopir5);
end cpu_16_beh;
