library ieee;
use ieee.std_logic_1164.all,ieee.numeric_std.all;

entity hazard is
port
(
	ir2:in std_logic_vector(15 downto 0);
	ir3:in std_logic_vector(15 downto 0);
	ir4:in std_logic_vector(15 downto 0);
	ir5:in std_logic_vector(15 downto 0);
	pause1:out std_logic;
	pause2:out std_logic;
	pause3:out std_logic;
	pause4:out std_logic;
	pause5:out std_logic;
	nopir2:out std_logic;
	nopir3:out std_logic;
	nopir4:out std_logic;
	nopir5:out std_logic
);
end hazard;

architecture hazard_beh of hazard is
begin
	process(ir2,ir3,ir4,ir5)
	variable opcode2:std_logic_vector(3 downto 0);
	variable opcode3:std_logic_vector(3 downto 0);
	variable opcode4:std_logic_vector(3 downto 0);
	variable opcode5:std_logic_vector(3 downto 0);
	variable arg12:std_logic_vector(3 downto 0);
	variable arg13:std_logic_vector(3 downto 0);
	variable arg14:std_logic_vector(3 downto 0);
	variable arg15:std_logic_vector(3 downto 0);
	variable arg22:std_logic_vector(3 downto 0);
	variable arg23:std_logic_vector(3 downto 0);
	variable arg24:std_logic_vector(3 downto 0);
	variable arg25:std_logic_vector(3 downto 0);
	variable nop:std_logic_vector(15 downto 0);
	variable stop:std_logic_vector(15 downto 0);
	begin
		opcode2:=ir2(15 downto 12);
		opcode3:=ir3(15 downto 12);
		opcode4:=ir4(15 downto 12);
		opcode5:=ir5(15 downto 12);
		arg12:=ir2(11 downto 8);
		arg13:=ir3(11 downto 8);
		arg14:=ir4(11 downto 8);
		arg15:=ir5(11 downto 8);
		arg22:=ir2(7 downto 4);
		arg23:=ir3(7 downto 4);
		arg24:=ir4(7 downto 4);
		arg25:=ir5(7 downto 4);
		nop:="1111111111111111";
		stop:="1111000000000000";

		pause1<='0';
		pause2<='0';
		pause3<='0';
		pause4<='0';
		pause5<='0';
		nopir2<='0';
		nopir3<='0';
		nopir4<='0';
		nopir4<='0';
		nopir5<='0';

		-- alu2 and alu3 and ((rb2=ra3) or (ra2=ra3))
		if((opcode2(3)='0' or opcode2="1000" or opcode2="1001") and (opcode3(3)='0' or opcode3="1000" or opcode3="1001") and (arg22=arg13 or arg12=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- alu2 and alu4 and ((rb2=ra4) or (ra2=ra4))
		if((opcode2(3)='0' or opcode2="1000" or opcode2="1001") and (opcode4(3)='0' or opcode4="1000" or opcode4="1001") and (arg22=arg14 or arg12=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- alu2 and alu5 and ((rb2=ra5) or (ra2=ra5))
		if((opcode2(3)='0' or opcode2="1000" or opcode2="1001") and (opcode5(3)='0' or opcode5="1000" or opcode5="1001") and (arg22=arg15 or arg12=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- alu2 and mov3 and ((rb2=ra3) or (ra2=ra3))
		if((opcode2(3)='0' or opcode2="1000" or opcode2="1001") and opcode3="1110" and (arg22=arg13 or arg12=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- alu2 and mov4 and ((rb2=ra4) or (ra2=ra4))
		if((opcode2(3)='0' or opcode2="1000" or opcode2="1001") and opcode4="1110" and (arg22=arg14 or arg12=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- alu2 and mov5 and ((rb2=ra5) or (ra2=ra5))
		if((opcode2(3)='0' or opcode2="1000" or opcode2="1001") and opcode5="1110" and (arg22=arg15 or arg12=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- alu2 and ld3 and ((rb2=ra3) or (ra2=ra3))
		if((opcode2(3)='0' or opcode2="1000" or opcode2="1001") and opcode3="1101" and (arg22=arg13 or arg12=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- alu2 and ld4 and ((rb2=ra4) or (ra2=ra4))
		if((opcode2(3)='0' or opcode2="1000" or opcode2="1001") and opcode4="1101" and (arg22=arg14 or arg12=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- alu2 and ld5 and ((rb2=ra5) or (ra2=ra5))
		if((opcode2(3)='0' or opcode2="1000" or opcode2="1001") and opcode5="1101" and (arg22=arg15 or arg12=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- st2 and alu3 and ((rb2=ra3) or (ra2=ra3))
		if(opcode2="1100" and (opcode3(3)='0' or opcode3="1000" or opcode3="1001") and (arg22=arg13 or arg12=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- st2 and alu4 and ((rb2=ra4) or (ra2=ra4))
		if(opcode2="1100" and (opcode4(3)='0' or opcode4="1000" or opcode4="1001") and (arg22=arg14 or arg12=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- st2 and alu5 and ((rb2=ra5) or (ra2=ra5))
		if(opcode2="1100" and (opcode5(3)='0' or opcode5="1000" or opcode5="1001") and (arg22=arg15 or arg12=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- st2 and mov3 and ((rb2=ra3) or (ra2=ra3))
		if(opcode3="1100" and opcode3="1110" and (arg22=arg13 or arg12=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- st2 and mov4 and ((rb2=ra4) or (ra2=ra4))
		if(opcode3="1100" and opcode4="1110" and (arg22=arg14 or arg12=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- st2 and mov5 and ((rb2=ra5) or (ra2=ra5))
		if(opcode3="1100" and opcode5="1110" and (arg22=arg15 or arg12=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- st2 and ld3 and ((rb2=ra3) or (ra2=ra3))
		if(opcode3="1100" and opcode3="1101" and (arg22=arg13 or arg12=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- st2 and ld4 and ((rb2=ra4) or (ra2=ra4))
		if(opcode3="1100" and opcode4="1101" and (arg22=arg14 or arg12=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- st2 and ld5 and ((rb2=ra5) or (ra2=ra5))
		if(opcode3="1100" and opcode5="1101" and (arg22=arg15 or arg12=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- ld2 and alu3 and (rb2=ra3)
		if(opcode2="1101" and (opcode3(3)='0' or opcode3="1000" or opcode3="1001") and (arg22=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- ld2 and alu4 and (rb2=ra4)
		if(opcode2="1101" and (opcode4(3)='0' or opcode4="1000" or opcode4="1001") and (arg22=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- ld2 and alu5 and (rb2=ra5)
		if(opcode2="1101" and (opcode5(3)='0' or opcode5="1000" or opcode5="1001") and (arg22=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- ld2 and mov3 and (rb2=ra3)
		if(opcode2="1101" and opcode3="1110" and (arg22=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- ld2 and mov4 and (rb2=ra4)
		if(opcode2="1101" and opcode4="1110" and (arg22=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- ld2 and mov5 and (rb2=ra5)
		if(opcode2="1101" and opcode5="1110" and (arg22=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- ld2 and ld3 and (rb2=ra3)
		if(opcode2="1101" and opcode3="1101" and (arg22=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- ld2 and ld4 and (rb2=ra4)
		if(opcode2="1101" and opcode4="1101" and (arg22=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- ld2 and ld5 and (rb2=ra5)
		if(opcode2="1101" and opcode5="1101" and (arg22=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- cmp2 and alu3 and ((rb2=ra3) or (ra2=ra3))
		if(opcode2="1010" and (opcode3(3)='0' or opcode3="1000" or opcode3="1001") and (arg22=arg13 or arg12=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- cmp2 and alu4 and ((rb2=ra4) or (ra2=ra4))
		if(opcode2="1010" and (opcode4(3)='0' or opcode4="1000" or opcode4="1001") and (arg22=arg14 or arg12=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- cmp2 and alu5 and ((rb2=ra5) or (ra2=ra5))
		if(opcode2="1010" and (opcode5(3)='0' or opcode5="1000" or opcode5="1001") and (arg22=arg15 or arg12=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- cmp2 and mov3 and ((rb2=ra3) or (ra2=ra3))
		if(opcode2="1010" and opcode3="1110" and (arg22=arg13 or arg12=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- cmp2 and mov4 and ((rb2=ra4) or (ra2=ra4))
		if(opcode2="1010" and opcode4="1110" and (arg22=arg14 or arg12=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- cmp2 and mov5 and ((rb2=ra5) or (ra2=ra5))
		if(opcode2="1010" and opcode5="1110" and (arg22=arg15 or arg12=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- cmp2 and ld3 and ((rb2=ra3) or (ra2=ra3))
		if(opcode2="1010" and opcode3="1101" and (arg22=arg13 or arg12=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- cmp2 and ld4 and ((rb2=ra4) or (ra2=ra4))
		if(opcode2="1010" and opcode4="1101" and (arg22=arg14 or arg12=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- cmp2 and ld5 and ((rb2=ra5) or (ra2=ra5))
		if(opcode2="1010" and opcode5="1101" and (arg22=arg15 or arg12=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- jmp2 and alu3 and (rb2=ra3)
		if(opcode2="1011" and (opcode3(3)='0' or opcode3="1000" or opcode3="1001") and (arg22=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- jmp2 and alu4 and (rb2=ra4)
		if(opcode2="1011" and (opcode4(3)='0' or opcode4="1000" or opcode4="1001") and (arg22=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- jmp2 and alu5 and (rb2=ra5)
		if(opcode2="1011" and (opcode5(3)='0' or opcode5="1000" or opcode5="1001") and (arg22=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- jmp2 and mov3 and (rb2=ra3)
		if(opcode2="1011" and opcode3="1110" and (arg22=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- jmp2 and mov4 and (rb2=ra4)
		if(opcode2="1011" and opcode4="1110" and (arg22=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- jmp2 and mov5 and (rb2=ra5)
		if(opcode2="1011" and opcode5="1110" and (arg22=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- jmp2 and ld3 and (rb2=ra3)
		if(opcode2="1011" and opcode3="1101" and (arg22=arg13)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- jmp2 and ld4 and (rb2=ra4)
		if(opcode2="1011" and opcode4="1101" and (arg22=arg14)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- jmp2 and ld5 and (rb2=ra5)
		if(opcode2="1011" and opcode5="1101" and (arg22=arg15)) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- jmp2 and cmp3
		if(opcode2="1011" and opcode3="1010") then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		end if;
		-- jmp2
		if(opcode2="1011") then
			pause1<='1';
			nopir2<='1';
		end if;

		-- stop
		if(ir2=stop) then
			pause1<='1';
			nopir2<='1';
		elsif(ir3=stop) then
			pause1<='1';
			pause2<='1';
			nopir3<='1';
		elsif(ir4=stop) then
			pause1<='1';
			pause2<='1';
			pause3<='1';
			nopir4<='1';
		elsif(ir5=stop) then
			pause1<='1';
			pause2<='1';
			pause3<='1';
			pause4<='1';
			pause5<='1';
		end if;
	end process;
end hazard_beh;
