library ieee;
use ieee.std_logic_1164.all,ieee.numeric_std.all;

entity ir_16 is
port
(
	clock:in std_logic;
	write:in std_logic;
	in0:in std_logic_vector(15 downto 0);
	out0:out std_logic_vector(15 downto 0);
	opcode:out std_logic_vector(3 downto 0);
	reg0:out std_logic_vector(3 downto 0);
	reg1:out std_logic_vector(3 downto 0);
	condition:out std_logic_vector(3 downto 0);
	const:out std_logic_vector(15 downto 0)
);
end ir_16;

architecture ir_16_beh of ir_16 is
signal reg:std_logic_vector(15 downto 0);
begin
	process(clock,write,in0,reg)
	begin
		if(reg="UUUUUUUUUUUUUUUU") then
			reg<="1111111111111111";
		end if;
		if(write='1' and clock='1') then
			reg<=in0 after 4 ns;
		end if;
		opcode<=reg(15 downto 12);
		reg0<=reg(11 downto 8);
		reg1<=reg(7 downto 4);
		condition<=reg(3 downto 0);
		const(15 downto 8)<="00000000";
		const(7 downto 0)<=reg(7 downto 0);
		out0<=reg;
	end process;
end ir_16_beh;
