library ieee;
use ieee.std_logic_1164.all,ieee.numeric_std.all;

entity regfile_16 is
port
(
	clock:in std_logic;
	write:in std_logic;
	sel_write_reg:in std_logic_vector(3 downto 0);
	sel_read_reg0:in std_logic_vector(3 downto 0);
	sel_read_reg1:in std_logic_vector(3 downto 0);
	write_data:in std_logic_vector(15 downto 0);
	read_data0:out std_logic_vector(15 downto 0);
	read_data1:out std_logic_vector(15 downto 0)
);
end regfile_16;

architecture regfile_16_beh of regfile_16 is
component and2_1 port
(
	in0:in std_logic;
	in1:in std_logic;
	out0:out std_logic
);
end component;
component decoder4to16_1 port
(
	in0:in std_logic_vector(3 downto 0);
	out0:out std_logic;
	out1:out std_logic;
	out2:out std_logic;
	out3:out std_logic;
	out4:out std_logic;
	out5:out std_logic;
	out6:out std_logic;
	out7:out std_logic;
	out8:out std_logic;
	out9:out std_logic;
	out10:out std_logic;
	out11:out std_logic;
	out12:out std_logic;
	out13:out std_logic;
	out14:out std_logic;
	out15:out std_logic
);
end component;
component mux16to1_16 port
(
	sel:in std_logic_vector(3 downto 0);
	in0:in std_logic_vector(15 downto 0);
	in1:in std_logic_vector(15 downto 0);
	in2:in std_logic_vector(15 downto 0);
	in3:in std_logic_vector(15 downto 0);
	in4:in std_logic_vector(15 downto 0);
	in5:in std_logic_vector(15 downto 0);
	in6:in std_logic_vector(15 downto 0);
	in7:in std_logic_vector(15 downto 0);
	in8:in std_logic_vector(15 downto 0);
	in9:in std_logic_vector(15 downto 0);
	in10:in std_logic_vector(15 downto 0);
	in11:in std_logic_vector(15 downto 0);
	in12:in std_logic_vector(15 downto 0);
	in13:in std_logic_vector(15 downto 0);
	in14:in std_logic_vector(15 downto 0);
	in15:in std_logic_vector(15 downto 0);
	out0:out std_logic_vector(15 downto 0)
);
end component;
component reg_16 port
(
	clock:in std_logic;
	write:in std_logic;
	in0:in std_logic_vector(15 downto 0);
	out0:out std_logic_vector(15 downto 0)
);
end component;
signal dec_out0:std_logic;
signal dec_out1:std_logic;
signal dec_out2:std_logic;
signal dec_out3:std_logic;
signal dec_out4:std_logic;
signal dec_out5:std_logic;
signal dec_out6:std_logic;
signal dec_out7:std_logic;
signal dec_out8:std_logic;
signal dec_out9:std_logic;
signal dec_out10:std_logic;
signal dec_out11:std_logic;
signal dec_out12:std_logic;
signal dec_out13:std_logic;
signal dec_out14:std_logic;
signal dec_out15:std_logic;
signal and_out0:std_logic;
signal and_out1:std_logic;
signal and_out2:std_logic;
signal and_out3:std_logic;
signal and_out4:std_logic;
signal and_out5:std_logic;
signal and_out6:std_logic;
signal and_out7:std_logic;
signal and_out8:std_logic;
signal and_out9:std_logic;
signal and_out10:std_logic;
signal and_out11:std_logic;
signal and_out12:std_logic;
signal and_out13:std_logic;
signal and_out14:std_logic;
signal and_out15:std_logic;
signal reg_out0:std_logic_vector(15 downto 0);
signal reg_out1:std_logic_vector(15 downto 0);
signal reg_out2:std_logic_vector(15 downto 0);
signal reg_out3:std_logic_vector(15 downto 0);
signal reg_out4:std_logic_vector(15 downto 0);
signal reg_out5:std_logic_vector(15 downto 0);
signal reg_out6:std_logic_vector(15 downto 0);
signal reg_out7:std_logic_vector(15 downto 0);
signal reg_out8:std_logic_vector(15 downto 0);
signal reg_out9:std_logic_vector(15 downto 0);
signal reg_out10:std_logic_vector(15 downto 0);
signal reg_out11:std_logic_vector(15 downto 0);
signal reg_out12:std_logic_vector(15 downto 0);
signal reg_out13:std_logic_vector(15 downto 0);
signal reg_out14:std_logic_vector(15 downto 0);
signal reg_out15:std_logic_vector(15 downto 0);
begin
	M0:decoder4to16_1 port map(sel_write_reg,dec_out0,dec_out1,dec_out2,dec_out3,dec_out4,dec_out5,dec_out6,dec_out7,dec_out8,dec_out9,dec_out10,dec_out11,dec_out12,dec_out13,dec_out14,dec_out15);
	M1:and2_1 port map(dec_out0,write,and_out0);
	M2:and2_1 port map(dec_out1,write,and_out1);
	M3:and2_1 port map(dec_out2,write,and_out2);
	M4:and2_1 port map(dec_out3,write,and_out3);
	M5:and2_1 port map(dec_out4,write,and_out4);
	M6:and2_1 port map(dec_out5,write,and_out5);
	M7:and2_1 port map(dec_out6,write,and_out6);
	M8:and2_1 port map(dec_out7,write,and_out7);
	M9:and2_1 port map(dec_out8,write,and_out8);
	M10:and2_1 port map(dec_out9,write,and_out9);
	M11:and2_1 port map(dec_out10,write,and_out10);
	M12:and2_1 port map(dec_out11,write,and_out11);
	M13:and2_1 port map(dec_out12,write,and_out12);
	M14:and2_1 port map(dec_out13,write,and_out13);
	M15:and2_1 port map(dec_out14,write,and_out14);
	M16:and2_1 port map(dec_out15,write,and_out15);
	M17:reg_16 port map(clock,and_out0,write_data,reg_out0);
	M18:reg_16 port map(clock,and_out1,write_data,reg_out1);
	M19:reg_16 port map(clock,and_out2,write_data,reg_out2);
	M20:reg_16 port map(clock,and_out3,write_data,reg_out3);
	M21:reg_16 port map(clock,and_out4,write_data,reg_out4);
	M22:reg_16 port map(clock,and_out5,write_data,reg_out5);
	M23:reg_16 port map(clock,and_out6,write_data,reg_out6);
	M24:reg_16 port map(clock,and_out7,write_data,reg_out7);
	M25:reg_16 port map(clock,and_out8,write_data,reg_out8);
	M26:reg_16 port map(clock,and_out9,write_data,reg_out9);
	M27:reg_16 port map(clock,and_out10,write_data,reg_out10);
	M28:reg_16 port map(clock,and_out11,write_data,reg_out11);
	M29:reg_16 port map(clock,and_out12,write_data,reg_out12);
	M30:reg_16 port map(clock,and_out13,write_data,reg_out13);
	M31:reg_16 port map(clock,and_out14,write_data,reg_out14);
	M32:reg_16 port map(clock,and_out15,write_data,reg_out15);
	M33:mux16to1_16 port map(sel_read_reg0,reg_out0,reg_out1,reg_out2,reg_out3,reg_out4,reg_out5,reg_out6,reg_out7,reg_out8,reg_out9,reg_out10,reg_out11,reg_out12,reg_out13,reg_out14,reg_out15,read_data0);
	M34:mux16to1_16 port map(sel_read_reg1,reg_out0,reg_out1,reg_out2,reg_out3,reg_out4,reg_out5,reg_out6,reg_out7,reg_out8,reg_out9,reg_out10,reg_out11,reg_out12,reg_out13,reg_out14,reg_out15,read_data1);
end regfile_16_beh;
