library ieee;
use ieee.std_logic_1164.all,ieee.numeric_std.all;

entity sreg is
port
(
	clock:in std_logic;
	write:in std_logic;
	in_cout_flag:in std_logic;
	in_zero_flag:in std_logic;
	in_overflow_flag:in std_logic;
	in_set_flag:in std_logic;
	out_cout_flag:out std_logic;
	out_zero_flag:out std_logic;
	out_overflow_flag:out std_logic;
	out_set_flag:out std_logic
);
end sreg;

architecture sreg_beh of sreg is
signal cout_flag:std_logic;
signal zero_flag:std_logic;
signal overflow_flag:std_logic;
signal set_flag:std_logic;
begin
	process(clock,write,in_cout_flag,in_zero_flag,in_overflow_flag,in_set_flag,cout_flag,zero_flag,overflow_flag,set_flag)
	begin
		if(write='1' and clock='1') then
			cout_flag<=in_cout_flag after 4 ns;
			zero_flag<=in_zero_flag after 4 ns;
			overflow_flag<=in_overflow_flag after 4 ns;
			set_flag<=in_set_flag after 4 ns;
		end if;
		out_cout_flag<=cout_flag;
		out_zero_flag<=zero_flag;
		out_overflow_flag<=overflow_flag;
		out_set_flag<=set_flag;
	end process;
end sreg_beh;
